#MIT License

#Copyright (c) 2020 Vladimir Lipp, Baerbel Rethfeld, Martin Garcia, Dmitry Ivanov

#Permission is hereby granted, free of charge, to any person obtaining a copy
#of this software and associated documentation files (the "Software"), to deal
#in the Software without restriction, including without limitation the rights
#to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
#copies of the Software, and to permit persons to whom the Software is
#furnished to do so, subject to the following conditions:

#The above copyright notice and this permission notice shall be included in all
#copies or substantial portions of the Software.

#THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
#SOFTWARE.

#include <fstream>
#include <iostream>
#include </gpfs/home08/0013/g47/gsl_installed/include/gsl/gsl_math.h>
#include </gpfs/home08/0013/g47/gsl_installed/include/gsl/gsl_sf_fermi_dirac.h>
     
int     gsl_sf_fermi_dirac_3half_e(const double x, gsl_sf_result * result);
double     gsl_sf_fermi_dirac_3half(const double x);

using namespace std;



     int
     main (void)
     {
	const int N = 100000;
	const double xmin=-25, xmax=30;
	double x, dx;
	double fd_32, fd_1, fd_12, fd0, fd12, fd1, fd32;
	int i;
	     
	x = xmin;
	dx = (xmax-xmin)/(N-1);
	     
	ofstream fermitab("fermi.tab");
	ofstream test("test_fermitab.dat");
	     
	fermitab.precision(17);
	fermitab << xmin << " " << xmax << " " << N-1 << endl;
	     
	     for (i=0;i<N;i++)
	     {		
		     
		fd_32 =( gsl_sf_fermi_dirac_mhalf(x+dx) - gsl_sf_fermi_dirac_mhalf(x-dx) ) / (2 * dx);
			
		fd_1   = gsl_sf_fermi_dirac_int(-1, x);
		fd_12 = gsl_sf_fermi_dirac_mhalf(x);
		fd0	  = gsl_sf_fermi_dirac_0(x);
		fd12   = gsl_sf_fermi_dirac_half(x);
		fd1	  = gsl_sf_fermi_dirac_1(x);
		fd32  = gsl_sf_fermi_dirac_3half(x);
		     
		     
		fermitab << x << " " << fd_32 << " " << fd_1 << " " << fd_12 << " " << fd0 << " " << fd12 << " " << fd1 << " " << fd32 << endl;
		test << x << " " << fd_32 << " " << fd_1 << " " << fd_12 << " " << fd0 << " " << fd12 << " " << fd1 << " " << fd32 << endl;
		     
		x = x + dx;
	     }
	     
	     
	fermitab.close();
       return 0;
     }